#
# This file was generated using xslt from its XML file
#
# Copyright 2008, Associated Universities Inc., Washington DC
#
import sys
import os
from casac import *
import string
import time
from casa_stack_manip import stack_frame_find
import gc
import numpy
from odict import odict
from task_importatca import importatca
from taskinit import casalog
from taskinit import xmlpath
class importatca_pg_:
    __name__ = "importatca"

    def __init__(self) :
       self.__bases__ = (importatca_pg_,)
       self.__doc__ = self.__call__.__doc__


    def __call__(self, files=None,vis=None,options=None,spw=None,nscans=None,lowfreq=None,highfreq=None,fields=None,edge=None,):

        myf=stack_frame_find( )
        myf['__last_task'] = 'importatca'
        myf['taskname'] = 'importatca'
        ###
        myf['update_params'](func=myf['taskname'],printtext=False)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
	function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames,self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True
                        #myf[key]=keyVal

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
                      if len(keyVal) > 0 :
		         exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')
		      else :
		         exec('myparams[key] = ' + key + ' = {}')

	else :
            uselessvariable = None 
            myparams['files'] = files = myf['files']
            myparams['vis'] = vis = myf['vis']
            myparams['options'] = options = myf['options']
            myparams['spw'] = spw = myf['spw']
            myparams['nscans'] = nscans = myf['nscans']
            myparams['lowfreq'] = lowfreq = myf['lowfreq']
            myparams['highfreq'] = highfreq = myf['highfreq']
            myparams['fields'] = fields = myf['fields']
            myparams['edge'] = edge = myf['edge']

        if type(files)==str: files=[files]
        if type(spw)==int: spw=[spw]
        if type(nscans)==int: nscans=[nscans]
        if type(fields)==str: fields=[fields]

	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['files'] = files
        mytmp['vis'] = vis
        mytmp['options'] = options
        mytmp['spw'] = spw
        mytmp['nscans'] = nscans
        if type(lowfreq) == str :
           mytmp['lowfreq'] = casac.quanta().quantity(lowfreq)
        else :
           mytmp['lowfreq'] = lowfreq
        if type(highfreq) == str :
           mytmp['highfreq'] = casac.quanta().quantity(highfreq)
        else :
           mytmp['highfreq'] = highfreq
        mytmp['fields'] = fields
        mytmp['edge'] = edge
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
	trec = casac.utils().torecord(pathname+'importatca.xml')

        casalog.origin('importatca')
        if not trec.has_key('importatca') or not casac.utils().verify(mytmp, trec['importatca']) :
	    return False


	try :
          casalog.post('')
          casalog.post('##########################################')
          casalog.post('##### Begin Task: importatca           #####')
          casalog.post('')
          result = importatca(files, vis, options, spw, nscans, lowfreq, highfreq, fields, edge)
          casalog.post('')
          casalog.post('##### End Task: importatca           #####')
          casalog.post('##########################################')


# saveinputs for individule engine has no use
# saveinputs should alos be removed from casa_in_py.py
#
#
#          saveinputs = myf['saveinputs']
#          saveinputs('importatca', 'importatca.last', myparams)
#
#
	except Exception, instance:
	  if(myf.has_key('__rethrow_casa_exceptions') and myf['__rethrow_casa_exceptions']) :
	     raise
	  else:
	     tname = 'importatca'
	     casalog.post('An error occurred running task %s: %s' % (tname,instance), 'ERROR')
	     pass
	casalog.origin('')

        gc.collect()
        return result
#
#
##
#    def paramgui(self, useGlobals=True):
#        """
#        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
#        """
#        import paramgui
#
#        myf = stack_frame_find( )
#
#        if useGlobals:
#            paramgui.setGlobals(myf)
#        else:
#            paramgui.setGlobals({})
#
#        paramgui.runTask('importatca', myf['_ip'])
#        paramgui.setGlobals({})
#
#
#
#
    def defaults(self, param=None):
        myf=stack_frame_find( )
        a = odict()
        a['files']  = ['']
        a['vis']  = ''
        a['options']  = ''
        a['spw']  = [-1]
        a['nscans']  = [0,0]
        a['lowfreq']  = '0.1GHz'
        a['highfreq']  = '999GHz'
        a['fields']  = ['']
        a['edge']  = 8


### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
	        if(a.has_key(param)):
		   #if(type(a[param]) == dict) :
		   #   return a[param][len(a[param])-1]['value']
	   	   #else :
		      return a[param]


#
#
    def check_params(self, param=None, value=None):
      myf=stack_frame_find( )

#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value

#
#
    def itsdefault(self, paramname) :
        a = {}
        a['files']  = ['']
        a['vis']  = ''
        a['options']  = ''
        a['spw']  = [-1]
        a['nscans']  = [0,0]
        a['lowfreq']  = '0.1GHz'
        a['highfreq']  = '999GHz'
        a['fields']  = ['']
        a['edge']  = 8

        if a.has_key(paramname) :
	      return a[paramname]
importatca_pg = importatca_pg_()
