#
# This file was generated using xslt from its XML file
#
# Copyright 2008, Associated Universities Inc., Washington DC
#
import sys
import os
from casac import *
import string
import time
from casa_stack_manip import stack_frame_find
import gc
import numpy
from odict import odict
from task_spxfit import spxfit
from taskinit import casalog
from taskinit import xmlpath
class spxfit_pg_:
    __name__ = "spxfit"

    def __init__(self) :
       self.__bases__ = (spxfit_pg_,)
       self.__doc__ = self.__call__.__doc__


    def __call__(self, imagename=None,box=None,region=None,chans=None,stokes=None,axis=None,mask=None,minpts=None,multifit=None,spxtype=None,spxest=None,spxfix=None,div=None,spxsol=None,spxerr=None,model=None,residual=None,wantreturn=None,stretch=None,logresults=None,logfile=None,append=None,sigma=None,outsigma=None,):

        myf=stack_frame_find( )
        myf['__last_task'] = 'spxfit'
        myf['taskname'] = 'spxfit'
        ###
        myf['update_params'](func=myf['taskname'],printtext=False)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
	function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames,self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True
                        #myf[key]=keyVal

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
                      if len(keyVal) > 0 :
		         exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')
		      else :
		         exec('myparams[key] = ' + key + ' = {}')

	else :
            uselessvariable = None 
            myparams['imagename'] = imagename = myf['imagename']
            myparams['box'] = box = myf['box']
            myparams['region'] = region = myf['region']
            myparams['chans'] = chans = myf['chans']
            myparams['stokes'] = stokes = myf['stokes']
            myparams['axis'] = axis = myf['axis']
            myparams['mask'] = mask = myf['mask']
            myparams['minpts'] = minpts = myf['minpts']
            myparams['multifit'] = multifit = myf['multifit']
            myparams['spxtype'] = spxtype = myf['spxtype']
            myparams['spxest'] = spxest = myf['spxest']
            myparams['spxfix'] = spxfix = myf['spxfix']
            myparams['div'] = div = myf['div']
            myparams['spxsol'] = spxsol = myf['spxsol']
            myparams['spxerr'] = spxerr = myf['spxerr']
            myparams['model'] = model = myf['model']
            myparams['residual'] = residual = myf['residual']
            myparams['wantreturn'] = wantreturn = myf['wantreturn']
            myparams['stretch'] = stretch = myf['stretch']
            myparams['logresults'] = logresults = myf['logresults']
            myparams['logfile'] = logfile = myf['logfile']
            myparams['append'] = append = myf['append']
            myparams['sigma'] = sigma = myf['sigma']
            myparams['outsigma'] = outsigma = myf['outsigma']

        if type(spxest)==float: spxest=[spxest]
        if type(spxfix)==bool: spxfix=[spxfix]

	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['imagename'] = imagename
        mytmp['box'] = box
        mytmp['region'] = region
        mytmp['chans'] = chans
        mytmp['stokes'] = stokes
        mytmp['axis'] = axis
        mytmp['mask'] = mask
        mytmp['minpts'] = minpts
        mytmp['multifit'] = multifit
        mytmp['spxtype'] = spxtype
        mytmp['spxest'] = spxest
        mytmp['spxfix'] = spxfix
        mytmp['div'] = div
        mytmp['spxsol'] = spxsol
        mytmp['spxerr'] = spxerr
        mytmp['model'] = model
        mytmp['residual'] = residual
        mytmp['wantreturn'] = wantreturn
        mytmp['stretch'] = stretch
        mytmp['logresults'] = logresults
        mytmp['logfile'] = logfile
        mytmp['append'] = append
        mytmp['sigma'] = sigma
        mytmp['outsigma'] = outsigma
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
	trec = casac.utils().torecord(pathname+'spxfit.xml')

        casalog.origin('spxfit')
        if not trec.has_key('spxfit') or not casac.utils().verify(mytmp, trec['spxfit']) :
	    return False


	try :
          casalog.post('')
          casalog.post('##########################################')
          casalog.post('##### Begin Task: spxfit           #####')
          casalog.post('')
          result = spxfit(imagename, box, region, chans, stokes, axis, mask, minpts, multifit, spxtype, spxest, spxfix, div, spxsol, spxerr, model, residual, wantreturn, stretch, logresults, logfile, append, sigma, outsigma)
          casalog.post('')
          casalog.post('##### End Task: spxfit           #####')
          casalog.post('##########################################')


# saveinputs for individule engine has no use
# saveinputs should alos be removed from casa_in_py.py
#
#
#          saveinputs = myf['saveinputs']
#          saveinputs('spxfit', 'spxfit.last', myparams)
#
#
	except Exception, instance:
	  if(myf.has_key('__rethrow_casa_exceptions') and myf['__rethrow_casa_exceptions']) :
	     raise
	  else:
	     tname = 'spxfit'
	     casalog.post('An error occurred running task %s: %s' % (tname,instance), 'ERROR')
	     pass
	casalog.origin('')

        gc.collect()
        return result
#
#
##
#    def paramgui(self, useGlobals=True):
#        """
#        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
#        """
#        import paramgui
#
#        myf = stack_frame_find( )
#
#        if useGlobals:
#            paramgui.setGlobals(myf)
#        else:
#            paramgui.setGlobals({})
#
#        paramgui.runTask('spxfit', myf['_ip'])
#        paramgui.setGlobals({})
#
#
#
#
    def defaults(self, param=None):
        myf=stack_frame_find( )
        a = odict()
        a['imagename']  = ''
        a['box']  = ''
        a['region']  = ''
        a['chans']  = ''
        a['stokes']  = ''
        a['axis']  = -1
        a['mask']  = ''
        a['minpts']  = 1
        a['multifit']  = False
        a['spxtype']  = 'plp'
        a['spxest']  = []
        a['spxfix']  = []
        a['div']  = 0
        a['wantreturn']  = True
        a['logresults']  = True
        a['logfile']  = ''
        a['sigma']  = ''

        a['mask'] = {
                    0:odict([{'notvalue':''}, {'stretch':False}])}
        a['multifit'] = {
                    0:{'value':False}, 
                    1:odict([{'value':True}, {'spxsol':""}, {'spxerr':""}, {'model':""}, {'residual':""}])}
        a['logfile'] = {
                    0:odict([{'notvalue':''}, {'append':True}])}
        a['sigma'] = {
                    0:odict([{'notvalue':''}, {'outsigma':''}])}

### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
	        if(a.has_key(param)):
		   #if(type(a[param]) == dict) :
		   #   return a[param][len(a[param])-1]['value']
	   	   #else :
		      return a[param]


#
#
    def check_params(self, param=None, value=None):
      myf=stack_frame_find( )

#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value

#
#
    def itsdefault(self, paramname) :
        a = {}
        a['imagename']  = ''
        a['box']  = ''
        a['region']  = ''
        a['chans']  = ''
        a['stokes']  = ''
        a['axis']  = -1
        a['mask']  = ''
        a['minpts']  = 1
        a['multifit']  = False
        a['spxtype']  = 'plp'
        a['spxest']  = []
        a['spxfix']  = []
        a['div']  = 0
        a['spxsol']  = ''
        a['spxerr']  = ''
        a['model']  = ''
        a['residual']  = ''
        a['wantreturn']  = True
        a['stretch']  = False
        a['logresults']  = True
        a['logfile']  = ''
        a['append']  = True
        a['sigma']  = ''
        a['outsigma']  = ''

        if a.has_key(paramname) :
	      return a[paramname]
spxfit_pg = spxfit_pg_()
